package provide DS9 1.0

proc InitXPA {} {
    global xpa
    global ds9
    global bin

    set xpa [xpacmdnew "DS9" $ds9(title)]

    xpacmdadd $xpa about \
	"\t-- get credits" \
	XPASendAbout "" "" \
	"" "" ""
    xpacmdadd $xpa analysis \
	"\[task number\]" \
	XPASendAnalysis "" "" \
	XPARcvdAnalysis "" ""

    xpacmdadd $xpa array \
	"\t\[\[xdim=<x>,ydim=<y>|dim=<dim>\],bitpix=<b>,\[skip=<s>\]\]" \
	XPASendArray "" "" \
	XPARcvdArray "" "fillbuf=false"

    xpacmdadd $xpa blink \
	"" \
	XPASendBlink "" "" \
	XPARcvdBlink "" ""

    xpacmdadd $xpa bin \
	$bin(help) \
	XPASendBin "" "" \
	XPARcvdBin "" ""

    xpacmdadd $xpa blocking \
	"for SAOtng backward compatibility" \
	XPASendBin "" "" \
	XPARcvdBin "" ""

    xpacmdadd $xpa colormap \
	"\[<colormap>\]\n                \[invert yes|no\]" \
	XPASendColormap "" "" \
	XPARcvdColormap "" ""

    xpacmdadd $xpa contour \
	"\[yes|no\]\n\t\t\[copy image|physical|fk4|fk5|icrs|galactic|ecliptic|linear\]\n\t\t\[paste image|physical|fk4|fk5|icrs|galactic|ecliptic|linear\]"\
	XPASendContour "" "" \
	XPARcvdContour "" ""

    xpacmdadd $xpa crosshair \
	"\[x y image|physical|fk4|fk5|icrs|galactic|ecliptic|linear\]" \
	XPASendCrosshair "" "" \
	XPARcvdCrosshair "" ""

    xpacmdadd $xpa cursor \
	"\t\[x y\] -- move pointer or crosshair" \
	"" "" "" \
	XPARcvdCursor "" ""

    xpacmdadd $xpa dss \
	"\t\[server sao|stsci|eso\]\n\t\t\[survey dss|dss2red|dss2blue\]\n\t\t\[name <object>\]\n\t\t\[x <fk5>\]\n\t\t\[y <fk5>\]\n\t\t\[width <arcmin>\]\n\t\t\[height <arcmin>\]\n\t\t\[<object>\]" \
	XPASendDSS "" "" \
	XPARcvdDSS "" ""

    xpacmdadd $xpa exit \
	"\t-- exit application" \
	"" "" "" \
	XPARcvdExit "" ""

    xpacmdadd $xpa file \
	"\t\[<filename>\]\n\t\t\[mosaicimage <filename>\]\n\t\t\[mosaicimages <filename>\]\n\t\t\[mosaic <filename>\]\n\t\t\[array <filename>\]\n\t\t\[save <filename>\]" \
	XPASendFile "" "" \
	XPARcvdFile "" ""

    xpacmdadd $xpa fits \
	"\t\[<options>\]" \
	XPASendFits "" "fillbuf=false" \
	XPARcvdFits "" "fillbuf=false"

    xpacmdadd $xpa frame \
	"\t\[center \[ |\#|all\]|clear \[ |\#|all\]|delete \[ |\#|all\]\]\n\t\t\[new|reset \[ |\#|all\]|refresh \[ |\#|all\]\]\n\t\t\[hide \[ |\#|all\]|show  \[\#|all\]\]\n\t\t\[first|next|prev|last|frameno \#| \#\]" \
	XPASendFrame "" "" \
	XPARcvdFrame "" ""

    xpacmdadd $xpa grid \
	"\t\[yes|no]" \
	XPASendGrid "" "" \
	XPARcvdGrid "" ""

    xpacmdadd $xpa iconify \
	"\[yes|no]" \
	XPASendIconify "" "" \
	XPARcvdIconify "" ""

    xpacmdadd $xpa lower \
	"\t-- lower window" \
	"" "" "" \
	XPARcvdLower "" ""

    xpacmdadd $xpa mode \
	"\t\[pointer|crosshair|colorbar|pan|zoom|rotate|examine\]" \
	XPASendMode "" "" \
	XPARcvdMode "" ""

    xpacmdadd $xpa nameserver \
	"\[server ned-sao|ned-eso|simbad-sao|simbad-eso\]\n\t\t\[format degrees|sexagesimal\]\n\t\t\[name <object>\]\n\t\t\[<object>\]" \
	XPASendNSVR "" "" \
	XPARcvdNSVR "" ""

    xpacmdadd $xpa orient \
	"\t\[none|X|Y|XY\] -- orient current frame" \
	XPASendOrient "" "" \
	XPARcvdOrient "" ""

    xpacmdadd $xpa {page setup} \
	"\[orientation portrait|landscape\]\n\t\t\[pagescale scaled|fixed\]\n\t\t\[pagesize letter|legal|a4\] -- print page setup" \
	XPASendPageSetup "" "" \
	XPARcvdPageSetup "" ""

    xpacmdadd $xpa pan \
	"\t\[x y image|physical|fk4|fk5|icrs|galactic|ecliptic|linear\]\n\t\t\[to x y image|physical|fk4|fk5|icrs|galactic|ecliptic|linear\]" \
	XPASendPan "" "" \
	XPARcvdPan "" ""

    xpacmdadd $xpa print \
	"\t\[destination printer|file\]\n\t\t\[command <command>\]\n\t\t\[filename <filename>\]\n\t\t\[palette rgb|cmyk|gray\]\n\t\t\[level 1|2\]\n\t\t\[interpolate yes|no\]\n\t\t\[resolution 53|72|75|150|300|600\]" \
	XPASendPrint "" "" \
	XPARcvdPrint "" ""

    xpacmdadd $xpa quit \
	"\t-- exit application" \
	"" "" "" \
	XPARcvdExit "" ""

    xpacmdadd $xpa raise \
	"\t-- raise window" \
	"" "" "" \
	XPARcvdRaise "" ""

    xpacmdadd $xpa rass \
	"\t\[server mpe\]\n\t\t\[survey broad|hard|soft|raw\]\n\t\t\[name <object>\]\n\t\t\[x <coord>\]\n\t\t\[y <coord>\]\n\t\t\[system fk4|fk5|icrs|galactic|ecliptic\]\n\t\t\[<object>\]" \
	XPASendRASS "" "" \
	XPARcvdRASS "" ""

    xpacmdadd $xpa regions \
	"\[movefront\]\n\t\t\[moveback\]\n\t\t\[selectall\]\n\t\t\[selectnone\]\n\t\t\[deleteall\]\n\t\t\[file <regions file>\]\n\t\t\[format\]\n\t\t\[-format ds9|saotng|saoimage|pros\]\n\t\t\[coord\]\n\t\t\[-coord image|physical|fk4|fk5|icrs|galactic|ecliptic|linear\]\n\t\t\[coordformat\]\n\t\t\[-coordformat degree|sexagesimal\]\n\t\t\[delim\]\n\t\t\[-delim nl|semicolon\]\n\t\t<region commands>" \
	XPASendRegions "" "" \
	XPARcvdRegions "" "fillbuf=false"

    xpacmdadd $xpa rotate \
	"\t\[<value>\]\n\t\t\[to <value>\]" \
	XPASendRotate "" "" \
	XPARcvdRotate "" ""

    xpacmdadd $xpa scale \
	"\t\[linear|log|squared|sqrt\]\n\t\t\[limits <minvalue> <maxvalue>\]\n\t\t\[mode\]\[minmax|zscale|user\]\n\t\t\[scope\]\[local|global\] -- color scale distribution" \
	XPASendScale "" "" \
	XPARcvdScale "" ""

    xpacmdadd $xpa single \
	"" \
	XPASendSingle "" "" \
	XPARcvdSingle "" ""

    xpacmdadd $xpa shm \
	"\t\[<key> <size> <filename>\]\n\t\t\[key <key> <size> <filename>\]\n\t\t\[shmid <shmid> <size> <filename>\]\n\t\t\[mosaicimage \[key|shmid\] <id> <size> <filename>\]\n\t\t\[mosaic \[key|shmid\] <id> <size> <filename>\]\n\t\t\[array \[key|shmid\] <id> <size> <filename>\]" \
	XPASendShm "" "" \
	XPARcvdShm "" ""

    xpacmdadd $xpa source \
	"\t\[filename\] -- source tcl source code" \
	"" "" "" \
	XPARcvdSource "" ""

    xpacmdadd $xpa tcl \
	"\t\[<tcl command>\] -- execute tcl command" \
	"" "" "" \
	XPARcvdTcl "" ""

    xpacmdadd $xpa tile \
	"\t\[\]\n\t\t\[mode grid|row|column\]" \
	XPASendTile "" "" \
	XPARcvdTile "" ""

    xpacmdadd $xpa update \
	"\t\[\]\n\t\t\[\# x1 y1 x2 y2\]" \
	"" "" "" \
	XPARcvdUpdate "" ""

    xpacmdadd $xpa view \
	"\t\[info yes|no\]\n\t\t\[panner yes|no\]\n\t\t\[magnifier yes|no\]\n\t\t\[buttons yes|no\]\n\t\t\[colorbar yes|no\]\n\t\t\[horzgraph yes|no\]\n\t\t\[vertgraph yes|no\]\n\t\t\[wcs yes|no\]\n\t\t\[detector yes|no\]\n\t\t\[amplifier yes|no\]\n\t\t\[physical yes|no\]\n\t\t\[image yes|no\] -- enable/disable gui display" \
	XPASendView "" "" \
	XPARcvdView "" ""

    xpacmdadd $xpa version \
	"-- display version" \
	XPASendVersion "" "" \
	"" "" ""
    xpacmdadd $xpa wcs \
	"\t\[fk4|fk5|icrs|galactic|ecliptic|linear\]\n\t\t\[align yes|no\]\n\t\t\[format degrees|sexagesimal\]" \
	XPASendWCS "" "" \
	XPARcvdWCS "" ""

    xpacmdadd $xpa zoom \
	"\t\[<value>\]\n\t\t\[to fit\]\n\t\t\[to <value>\]" \
	XPASendZoom "" "" \
	XPARcvdZoom "" ""
}

proc XPASendAbout {xpa cdata param} {
    xpasetbuf $xpa [AboutMessage]
}

proc XPASendAnalysis {xpa cdata param} {
    global analysisMenu
    global analysisType
    global analysisCmd

    set result ""
    foreach a [array names analysisMenu] {
	set result "$result\#$a"
	set result "$result\n$analysisMenu($a)"
	set result "$result\n$analysisType($a)"
	set result "$result\n$analysisCmd($a)"
	set result "$result\n\n"
    }
    xpasetbuf $xpa $result
}

proc XPARcvdAnalysis {xpa cdata param buf len} {
    AnalysisCmd $param
}

proc XPASendArray {xpa cdata param} {
    global current
    if {$current(frame) != ""} {
	xpasetbuf $xpa "[$current(frame) get fits full file names]\n"
    }
}

proc XPARcvdArray {xpa cdata param buf len} {
    global current

    if {$current(frame) != ""} {
	StartLoad
	set ch [xparec $xpa datachan]
	fconfigure $ch -translation binary
	if {[catch {$current(frame) load array channel $ch $param}]} {
	    xpaerror $xpa "Unable to load Array File"
	}
	FinishLoad
    }
}

proc XPASendBlink {xpa cdata param} {
    global ds9
    if {$ds9(displaymode) == "blink"} {
	xpasetbuf $xpa [ToYesNo 1]
    } else {
	xpasetbuf $xpa [ToYesNo 0]
    }
}

proc XPARcvdBlink {xpa cdata param buf len} {
    global ds9
    set ds9(displaymode) blink
    DisplayMode
}

proc XPASendBin {xpa cdata param} {
    global bin
    global current

    switch -- [string tolower $param] {
	about {
	    if {$current(frame) != ""} {
		xpasetbuf $xpa "[$current(frame) get bin cursor]\n"
	    }
	}
	buffersize {xpasetbuf $xpa "$bin(buffersize)\n"}
	cols {
	    if {$current(frame) != ""} {
		xpasetbuf $xpa "[$current(frame) get bin cols]\n"
	    }
	}
	factor {xpasetbuf $xpa "$bin(factor)\n"}
	filter {
	    if {$current(frame) != ""} {
		xpasetbuf $xpa "[$current(frame) get bin filter]\n"
	    }
	}
	function {xpasetbuf $xpa "$bin(function)\n"}
	default {xpaerror $xpa "Illegal option: $param"}
    }
}

proc XPARcvdBin {xpa cdata param buf len} {
    set i 0
    ProcessBin param i
}

proc XPASendContour {xpa cdata param} {
    global contour
    xpasetbuf $xpa [ToYesNo $contour(view)]
}

proc XPARcvdContour {xpa cdata param buf len} {
    global contour
    global current
    switch -- [string tolower [lindex $param 0]] {
	copy {ContourCopy}
	paste {ContourPaste [lindex $param 1]}
	default {
	    set contour(view) [FromYesNo $param]
	    ContourUpdate
	}
    }
}

proc XPASendColormap {xpa cdata param} {
    global colorbar
    switch -- [string tolower $param] {
	invert {xpasetbuf $xpa [ToYesNo $colorbar(invert)]}
	{} {xpasetbuf $xpa "$colorbar(map)\n"}
	default {xpaerror $xpa "Illegal option: $param"}
    }
}

proc XPARcvdColormap {xpa cdata param buf len} {
    global colorbar
    set i 0
    set l [llength $param]
    while {$i < $l} {
	set item [lindex $param $i]
	switch -- $item {
	    invert {
		incr i
		set colorbar(invert) [FromYesNo [lindex $param $i]]
		InvertColorbar
	    }
	    default {
		set colorbar(map) $item
		ChangeColormap
	    }
	}
	incr i
    }
}

proc XPASendCrosshair {xpa cdata param} {
    global current
    set sys $param
    if {$current(frame) != ""} {
	if {$sys == ""} {
	    set sys image
	}
	xpasetbuf $xpa "[$current(frame) get crosshair $sys]\n"
    }
}

proc XPARcvdCrosshair {xpa cdata param buf len} {
    global current
    global ds9
    if {$current(frame) != ""} {
	set x [lindex $param 0]
	set y [lindex $param 1]
	set sys [lindex $param 2]
	if {$sys == ""} {
	    set sys image
	}
	set ds9(mode) crosshair
	ChangeMode
	$current(frame) crosshair $x $y $sys
	set coord [$current(frame) get crosshair]
	UpdateInfoBox $current(frame) \
	    [lindex $coord 0] [lindex $coord 1] canvas
    }
}

proc XPARcvdCursor {xpa cdata param buf len} {
    global current
    if {$current(frame) != ""} {
	set x [lindex $param 0]
	set y [lindex $param 1]
	ArrowKeyFrame $current(frame) $x $y
    }
}

proc XPASendDSS {xpa cdata param} {
    global dss

    switch -- [string tolower [lindex $param 0]] {
	server {xpasetbuf $xpa "$dss(server)\n"}
	survey {xpasetbuf $xpa "$dss(survey)\n"}
	name {xpasetbuf $xpa "$dss(name)\n"}
	x {xpasetbuf $xpa "$dss(x)\n"}
	y {xpasetbuf $xpa "$dss(y)\n"}
	width {xpasetbuf $xpa "$dss(width)\n"}
	height {xpasetbuf $xpa "$dss(height)\n"}
	default {xpasetbuf $xpa "$dss(name)\n"}
    }
}

proc XPARcvdDSS {xpa cdata param buf len} {
    global dss

    set i 0
    set l [llength $param]
    while {$i < $l} {
	set item [lindex $param $i]
	switch -- $item {
	    server {incr i; set dss(server) [lindex $param $i]}
	    survey {incr i; set dss(survey) [lindex $param $i]}
	    name {incr i; set dss(name) [lindex $param $i]}
	    x {incr i; set dss(x) [lindex $param $i]}
	    y {incr i; set dss(y) [lindex $param $i]}
	    width {incr i; set dss(width) [lindex $param $i]}
	    height {incr i; set dss(height) [lindex $param $i]}
	    default {set dss(name) [lindex $param $i]}
	}
	incr i
    }

    DSSDialog
    DSSApplyDialog
}

proc XPARcvdExit {xpa cdata param buf len} {
    QuitDS9
}

proc XPASendFile {xpa cdata param} {
    global current
    if {$current(frame) != ""} {
	xpasetbuf $xpa "[$current(frame) get fits full file names]\n"
    }
}

proc XPARcvdFile {xpa cdata param buf len} {
    global ds9
    global current

    set ds9(xpa) $xpa
    switch -- [lindex $param 0] {
	array {LoadArray [lindex $param 1]}
	mosaicimage {LoadMosaicImageFile [lindex $param 1]}
	mosaicimages {LoadMosaicFiles [lindex $param 1]}
	mosaic {LoadFits [lindex $param 1] mosaic}
	save {$current(frame) save fits file [lindex $param 1]}
	default {LoadFits $param ""}
    }
    set ds9(xpa) 0
}

proc XPASendFits {xpa cdata param} {
    global current

    if {$current(frame) != ""} {
	set ch [xparec $xpa datachan]
	fconfigure $ch -translation binary
	$current(frame) save fits channel $ch
    }
}

proc XPARcvdFits {xpa cdata param buf len} {
    global current
    if {$current(frame) != ""} {
	StartLoad
	set ch [xparec $xpa datachan]
	fconfigure $ch -translation binary
	if {[catch {$current(frame) load fits channel $ch $param}]} {
	    xpaerror $xpa "Unable to load Fits File"
	}
	FinishLoad
    }
}

proc XPASendFrame {xpa cdata param} {
    global current
    switch [lindex $param 0] {
	active {
	    global ds9

	    set r ""
	    foreach f $ds9(active) {
		append r "[string range $f 5 end] "
	    }
	    xpasetbuf $xpa "$r\n"
	}
	all {
	    global ds9

	    set r ""
	    foreach f $ds9(frames) {
		append r "[string range $f 5 end] "
	    }
	    xpasetbuf $xpa "$r\n"
	}
	default {xpasetbuf $xpa "[string range $current(frame) 5 end]\n"}
    }
}

proc XPARcvdFrame {xpa cdata param buf len} {
    global current
    global ds9
    global active

    set cmd [string tolower [lindex $param 0]]
    switch -- $cmd {
	center {
	    switch [lindex $param 1] {
		all {CenterAllFrame}
		"" {CenterCurrentFrame}
		default {
		    set f "Frame[lindex $param 1]"
		    CenterFrame $f
		}
	    }
	}
	clear {
	    switch [lindex $param 1] {
		all {ClearAllFrame}
		"" {ClearCurrentFrame}
		default {
		    set f "Frame[lindex $param 1]"
		    ClearFrame $f
		}
	    }
	}
	delete {
	    switch [lindex $param 1] {
		all {DeleteAllFrame}
		"" {DeleteCurrentFrame}
		default {
		    set f "Frame[lindex $param 1]"
		    DeleteFrame $f
		}
	    }
	}
	new {CreateFrame}
	reset {
	    switch [lindex $param 1] {
		all {ResetAllFrame}
		"" {ResetCurrentFrame}
		default {
		    set f "Frame[lindex $param 1]"
		    ResetFrame $f
		}
	    }
	}
	refresh {
	    switch [lindex $param 1] {
		all {UpdateAllFrame}
		"" {UpdateCurrentFrame}
		default {
		    set f "Frame[lindex $param 1]"
		    UpdateFrame $f
		}
	    }
	}
	hide {
	    switch [lindex $param 1] {
		all {ActiveFrameNone}
		"" {
		    set active($current(frame)) 0
		    UpdateActiveFrames
		}
		default {
		    set f "Frame[lindex $param 1]"
		    set active($f) 0
		    UpdateActiveFrames
		}
	    }
	}
	show {
	    switch [lindex $param 1] {
		all {ActiveFrameAll}
		default {
		    set f "Frame[lindex $param 1]"
		    set active($f) 1
		    UpdateActiveFrames
		}
	    }
	}
	first {FirstFrame}
	next {NextFrame}
	prev {PrevFrame}
	last {LastFrame}
	frameno {CreateGotoFrame [lindex $param 1]}
	default {CreateGotoFrame [lindex $param 0]}
    }
}

proc XPASendGrid {xpa cdata param} {
    global grid
    xpasetbuf $xpa [ToYesNo $grid(view)]
}

proc XPARcvdGrid {xpa cdata param buf len} {
    global grid
    set grid(view) [FromYesNo $param]
    GridUpdate
}

proc XPASendIconify {xpa cdata param} {
    global ds9
    if {[wm state $ds9(top)] == "normal"} {
	xpasetbuf $xpa "no\n"
    } else {
	xpasetbuf $xpa "yes\n"
    }
}

proc XPARcvdIconify {xpa cdata param buf len} {
    global ds9
    if {[FromYesNo $param]} {
	wm iconify $ds9(top)
    } else {
	wm deiconify $ds9(top)
    }
}

proc XPARcvdLower {xpa cdata param buf len} {
    global ds9
    lower $ds9(top)
}

proc XPASendMode {xpa cdata param} {
    global ds9
    xpasetbuf $xpa "$ds9(mode)\n"
}

proc XPARcvdMode {xpa cdata param buf len} {
    global ds9
    set ds9(mode) [string tolower $param]
    ChangeMode
}

proc XPASendNSVR {xpa cdata param} {
    global nsvr

    switch -- [string tolower [lindex $param 0]] {
	server {xpasetbuf $xpa "$nsvr(server)\n"}
	format {xpasetbuf $xpa "$nsvr(format)\n"}
	name {xpasetbuf $xpa "$nsvr(name)\n"}
	default {
	    set nsvr(name) [lindex $param 0]
	    NSVRDialog
	    NSVRApplyDialog
	    xpasetbuf $xpa "$nsvr(x) $nsvr(y)\n"
	}
    }
}

proc XPARcvdNSVR {xpa cdata param buf len} {
    global nsvr

    set i 0
    set l [llength $param]
    while {$i < $l} {
	set item [lindex $param $i]
	switch -- $item {
	    server {incr i; set nsvr(server) [lindex $param $i]}
	    format {incr i; set nsvr(format) [lindex $param $i]}
	    name {incr i; set nsvr(name) [lindex $param $i]}
	    default {set nsvr(name) [lindex $param $i]}
	}
	incr i
    }
}

proc XPASendOrient {xpa cdata param} {
    global current
    xpasetbuf $xpa "$current(orient)\n"
}

proc XPARcvdOrient {xpa cdata param buf len} {
    global current
    set current(orient) [string tolower $param]
    ChangeOrient
}

proc XPASendPageSetup {xpa cdata param} {
    global ps
    switch -- [string tolower $param] {
	orientation {xpasetbuf $xpa "$ps(orient)\n"}
	pagescale {xpasetbuf $xpa "$ps(scale)\n"}
	pagesize {xpasetbuf $xpa "$ps(size)\n"}
    }
}

proc XPARcvdPageSetup {xpa cdata param buf len} {
    global ps

    set i 0
    set l [llength $param]
    while {$i < $l} {
	set item [lindex $param $i]
	switch -- $item {
	    orientation {incr i; set ps(orient) [lindex $param $i]}
	    pagescale {incr i; set ps(scale) [lindex $param $i]}
	    pagesize {incr i; set ps(size) [lindex $param $i] }
	}
	incr i
    }
}

proc XPASendPan {xpa cdata param} {
    global current
    if {$current(frame) != ""} {
	if {$param == ""} {
	    set param image
	}
	xpasetbuf $xpa "[$current(frame) get pan $param]\n"
    }
}

proc XPARcvdPan {xpa cdata param buf len} {
    if {[string tolower [lindex $param 0]] != "to"} {
	set x [lindex $param 0]
	set y [lindex $param 1]
	set sys [lindex $param 2]
	Pan $x $y $sys
    } else {
	set x [lindex $param 1]
	set y [lindex $param 2]
	set sys [lindex $param 3]
	PanTo $x $y $sys
    }
}

proc XPASendPrint {xpa cdata param} {
    global ps
    switch -- [string tolower $param] {
	destination {xpasetbuf $xpa "$ps(dest)\n"}
	command {xpasetbuf $xpa "$ps(cmd)\n"}
	filename {xpasetbuf $xpa "$ps(fileName)\n"}
	palette {xpasetbuf $xpa "$ps(color)\n"}
	level {xpasetbuf $xpa "$ps(level)\n"}
	interpolate {xpasetbuf $xpa [ToYesNo $ps(interpolate)]}
	resolution {xpasetbuf $xpa "$ps(resolution)\n"}
    }
}

proc XPARcvdPrint {xpa cdata param buf len} {
    global ps

    set i 0
    set l [llength $param]
    if {$l > 0} {
	while {$i < $l} {
	    set item [lindex $param $i]
	    switch -- $item {
		destination {incr i; set ps(dest) [lindex $param $i]}
		command {incr i; set ps(cmd) [lindex $param $i]}
		filename {incr i; set ps(fileName) [lindex $param $i] }
		palette {incr i; set ps(color) [lindex $param $i] }
		level {incr i; set ps(level) [lindex $param $i] }
		interpolate 
		{incr i; set ps(interpolate) [FromYesNo [lindex $param $i]]}
		resolution {incr i; set ps(resolution) [lindex $param $i] }
	    }
	    incr i
	}
    } else {
	PostScript
    }
}

proc XPARcvdRaise {xpa cdata param buf len} {
    global ds9
    raise $ds9(top)
}

proc XPASendRASS {xpa cdata param} {
    global rass

    switch -- [string tolower [lindex $param 0]] {
	server {xpasetbuf $xpa "$rass(server)\n"}
	survey {xpasetbuf $xpa "$rass(survey)\n"}
	name {xpasetbuf $xpa "$rass(name)\n"}
	x {xpasetbuf $xpa "$rass(x)\n"}
	y {xpasetbuf $xpa "$rass(y)\n"}
	system {xpasetbuf $xpa "$rass(system)\n"}
	default {xpasetbuf $xpa "$rass(name)\n"}
    }
}

proc XPARcvdRASS {xpa cdata param buf len} {
    global rass

    set i 0
    set l [llength $param]
    while {$i < $l} {
	set item [lindex $param $i]
	switch -- $item {
	    server {incr i; set rass(server) [lindex $param $i]}
	    survey {incr i; set rass(survey) [lindex $param $i]}
	    name {incr i; set rass(name) [lindex $param $i]}
	    x {incr i; set rass(x) [lindex $param $i]}
	    y {incr i; set rass(y) [lindex $param $i]}
	    system {incr i; set rass(system) [lindex $param $i]}
	    default {set rass(name) [lindex $param $i]}
	}
	incr i
    }

    RASSDialog
    RASSApplyDialog
}

proc XPASendRegions {xpa cdata param} {
    global current
    global marker

    if {$current(frame) != ""} {
	set item [lindex $param 0]
	switch -- $item {
	    format {xpasetbuf $xpa "$marker(format)\n"}
	    coord {xpasetbuf $xpa "$marker(coord)\n"}
	    coordformat {xpasetbuf $xpa "$marker(coordformat)\n"}
	    delim {xpasetbuf $xpa "$marker(delim)\n"}

	    default {
		set format $marker(format)
		set coord $marker(coord)
		set coordformat $marker(coordformat)
		set delim $marker(delim)

		set i 0
		set l [llength $param]
		while {$i < $l} {
		    switch -- [lindex $param $i] {
			-format {incr i; set format [lindex $param $i]}
			-coord  {incr i; set coord [lindex $param $i]}
			-coordformat 
			{incr i;set coordformat [lindex $param $i]}
			-delim  {incr i; set delim [lindex $param $i]}
		    }
		    incr i
		}
		xpasetbuf $xpa [$current(frame) marker list \
				    $format $coord $coordformat $delim]
	    }
	}
    }
}

proc XPARcvdRegions {xpa cdata param buf len} {
    global current
    global marker

    if {$current(frame) == ""} {
	xpaerror $xpa "No frame available"
	return
    }

    if {![$current(frame) has fits]} {
	xpaerror $xpa "No data loaded"
	return
    }
    

    if {$param != ""} {
	switch -- [lindex $param 0] {
	    movefront {$current(frame) marker move front}
	    moveback {$current(frame) marker move back}

	    selectall {$current(frame) marker select all}
	    selectnone {$current(frame) marker unselect all}
	    deleteall {$current(frame) marker delete all}

	    file {catch {$current(frame) marker load \
			     $marker(format) [lindex $param 1]}}
	    format {
		set marker(format) [lindex $param 1]
		UpdateMarkerFormatMenu
	    }
	    coord {set marker(coord) [lindex $param 1]}
	    coordformat {set marker(coordformat) [lindex $param 1]}
	    delim {set marker(delim) [lindex $param 1]}

	    default {catch {$current(frame) marker command \
				$marker(format) $param}}
	}
    } else {
	# read from tcl channel
	set fd [xparec $xpa datafd]
	$current(frame) marker load $marker(format) $fd
    }
}

proc XPASendRotate {xpa cdata param} {
    global current
    xpasetbuf $xpa "$current(rotate)\n"
}

proc XPARcvdRotate {xpa cdata param buf len} {
    global current
    if {[string tolower [lindex $param 0]] != "to"} {
	Rotate $param
    } else {
	set current(rotate) [lindex $param 1]
	ChangeRotate
    }
}

proc XPASendScale {xpa cdata param} {
    global current
    global scale
    switch -- [string tolower $param] {
	limits {
	    if {$current(frame) != ""} {
		set lims [$current(frame) get clip default]
		xpasetbuf $xpa "[lindex $lims 0] [lindex $lims 1]\n"
	    }
	}
	mode {xpasetbuf $xpa "$scale(mode)\n"}
	scope {xpasetbuf $xpa "$scale(scope)\n"}
	default {xpasetbuf $xpa "$current(scale)\n"}
    }
}

proc XPARcvdScale {xpa cdata param buf len} {
    global current
    global scale
    global user

    set i 0
    set l [llength $param]
    while {$i < $l} {
	set item [lindex $param $i]
	switch -- $item {
	    limits {
		incr i
		set user(low) [lindex $param $i]
		incr i
		set user(high) [lindex $param $i]
		ScaleLimit $user(low) $user(high)
	    }
	    mode {
		incr i
		set scale(mode) [string tolower [lindex $param $i]]
		ScaleMode
	    }
	    minmax -
	    zscale -
	    user {
		set scale(mode) [string tolower [lindex $param $i]]
		ScaleMode
	    }
	    scope {
		incr i
		set scale(scope) [string tolower [lindex $param $i]]
		ScaleScope
	    }
	    local -
	    global{
		set scale(scope) [string tolower [lindex $param $i]]
		ScaleScope
	    }
	    default {
		set current(scale) [string tolower $item]
		ChangeColorScale
	    }
	}
	incr i
    }
}

proc XPASendSingle {xpa cdata param} {
    global ds9
    if {$ds9(displaymode) == "single"} {
	xpasetbuf $xpa [ToYesNo 1]
    } else {
	xpasetbuf $xpa [ToYesNo 0]
    }
}

proc XPARcvdSingle {xpa cdata param buf len} {
    global ds9
    set ds9(displaymode) single
    DisplayMode
}

proc XPASendShm {xpa cdata param} {
    global current
    if {$current(frame) != ""} {
	xpasetbuf $xpa "[$current(frame) get fits full file names]\n"
    }
}

proc XPARcvdShm {xpa cdata param buf len} {
    global ds9

    set ds9(xpa) $xpa
    switch -- [lindex $param 0] {
	array {LoadShared array {} [lindex $param 1] \
		   [lindex $param 2] [lindex $param 3] [lindex $param 4]}
	mosaic {LoadShared fits mosaic [lindex $param 1] [lindex $param 2] \
		    [lindex $param 3] [lindex $param 4]}
	mosaicimage {LoadShared fits {mosaic image} [lindex $param 1] \
			 [lindex $param 2] [lindex $param 3] [lindex $param 4]}
	key -
	shmid {LoadShared fits {} [lindex $param 0] [lindex $param 1] \
		   [lindex $param 2] [lindex $param 3]}
	default {LoadShared fits {} key [lindex $param 0] \
		   [lindex $param 1] [lindex $param 2]}
    }
    set ds9(xpa) 0
}

proc XPARcvdSource {xpa cdata param buf len} {
    uplevel #0 source $param
}

proc XPARcvdTcl {xpa cdata param buf len} {
    if [string compare $param {}] {
	uplevel #0 eval $param
    } else {
	uplevel #0 eval $buf
    }
}

proc XPASendTile {xpa cdata param} {
    global ds9
    global tile
    switch -- $param {
	mode {xpasetbuf $xpa "$tile(mode)\n"}
	default {
	    if {$ds9(displaymode)=="tile"} {
		xpasetbuf $xpa [ToYesNo 1]
	    } else {
		xpasetbuf $xpa [ToYesNo 0]
	    }
	}
    }
}

proc XPARcvdTile {xpa cdata param buf len} {
    global ds9
    global tile
    switch -- [lindex $param 0] {
	mode {set tile(mode) [lindex $param 1]}
	default {set ds9(displaymode) tile}
    }
    DisplayMode
}

proc XPARcvdUpdate {xpa cdata param buf len} {
    global current

    if {$current(frame) != ""} {
	if {[lindex $param 0] != ""} {
	    $current(frame) update [lindex $param 0] \
		[lindex $param 1] [lindex $param 2] \
		[lindex $param 3] [lindex $param 4]
	} else {
	    $current(frame) update
	}
    }
}

proc XPASendView {xpa cdata param} {
    global info
    global pan
    global mag
    global buttons
    global colorbar
    global graphHorz
    global graphVert

    switch -- [string tolower $param] {
	info {xpasetbuf $xpa [ToYesNo $info(view)]}
	panner {xpasetbuf $xpa [ToYesNo $pan(view)]}
	magnifier {xpasetbuf $xpa [ToYesNo $mag(view)]}
	buttons {xpasetbuf $xpa [ToYesNo $buttons(view)]}
	colorbar {xpasetbuf $xpa [ToYesNo $colorbar(view)]}
	horzgraph {xpasetbuf $xpa [ToYesNo $graphHorz(view)]}
	vertgraph {xpasetbuf $xpa [ToYesNo $graphVert(view)]}

	wcs {xpasetbuf $xpa [ToYesNo $info(wcs)]}
	detector {xpasetbuf $xpa [ToYesNo $info(detector)]}
	amplifier {xpasetbuf $xpa [ToYesNo $info(amplifier)]}
	physical {xpasetbuf $xpa [ToYesNo $info(physical)]}
	image {xpasetbuf $xpa [ToYesNo $info(image)]}
	default {xpaerror $xpa "Illegal option: $param"}
    }
}

proc XPARcvdView {xpa cdata param buf len} {
    global info
    global pan
    global mag
    global buttons
    global colorbar
    global graphHorz
    global graphVert

    set i 0
    set l [llength $param]
    while {$i < $l} {
	set item [lindex $param $i]
	switch -- $item {
	    info {incr i; set info(view) [FromYesNo [lindex $param $i]]}
	    panner {incr i; set pan(view) [FromYesNo [lindex $param $i]]}
	    magnifier {incr i; set mag(view) [FromYesNo [lindex $param $i]]}
	    buttons {incr i; set buttons(view) [FromYesNo [lindex $param $i]]}
	    colorbar 
	    {incr i; set colorbar(view) [FromYesNo [lindex $param $i]]}
	    horzgraph 
	    {incr i; set graphHorz(view) [FromYesNo [lindex $param $i]]}
	    vertgraph 
	    {incr i; set graphVert(view) [FromYesNo [lindex $param $i]]}

	    wcs {incr i; set info(wcs) [FromYesNo [lindex $param $i]]}
	    detector 
	    {incr i; set info(detector) [FromYesNo [lindex $param $i]]}
	    amplifier 
	    {incr i; set info(amplifier) [FromYesNo [lindex $param $i]]}
	    physical 
	    {incr i; set info(physical) [FromYesNo [lindex $param $i]]}
	    image {incr i; set info(image) [FromYesNo [lindex $param $i]]}
	}
	incr i
    }
    UpdateView
    UpdateInfoPanel
}

proc XPASendVersion {xpa cdata param} {
    global ds9
    xpasetbuf $xpa "$ds9(title) $ds9(version)\n"
}

proc XPASendWCS {xpa cdata param} {
    global wcs
    switch -- [string tolower $param] {
	align {xpasetbuf $xpa [ToYesNo $wcs(align)]}
	format {xpasetbuf $xpa "$wcs(format)\n"}
	default {xpasetbuf $xpa "$wcs(system)\n"}
    }
}

proc XPARcvdWCS {xpa cdata param buf len} {
    global wcs

    set i 0
    set l [llength $param]
    while {$i < $l} {
	set item [lindex $param $i]
	switch -- $item {
	    align {
		incr i
		set wcs(align) [FromYesNo [lindex $param $i]]
		AlignWCSFrame
	    }
	    format {incr i; set wcs(format) [string tolower [lindex $param $i]]}
	    default {set wcs(system) [string tolower $item]}
	}
	incr i
    }
}

proc XPASendZoom {xpa cdata param} {
    global current
    xpasetbuf $xpa "$current(zoom)\n"
}

proc XPARcvdZoom {xpa cdata param buf len} {
    global current
    
    switch -- [lindex $param 0] {
	to {
	    switch -- [lindex $param 1] {
		fit {ZoomToFit}
		default {
		    set current(zoom) [lindex $param 1]
		    ChangeZoom
		}
	    }
	}
	default {Zoom $param}
    }
}

proc ToYesNo {value} {
    if {$value == 1} {
	return "yes\n"
    } else {
	return "no\n"
    }
}

proc FromYesNo {value} {
    set v [string tolower $value]

    if {$v == "no" || $v == "false" || $v == "off" || $v == 0} {
	return 0
    } else {
	return 1
    }
}
