#define IMREGIONS_C "\n\
#ifndef SELF_CONTAINED\n\
#include \"regions.h\"\n\
#endif\n\
\n\
/* adding this to FilterOpen will cause this module to be loaded\n\
   for dynamic linking */\n\
static int imregno=0;\n\
void initimregions(void)\n\
{\n\
  imregno++;\n\
  return;\n\
}\n\
\n\
static void marky(GFilt g, int sno, int flag)\n\
{\n\
  int i;\n\
  /* mark include shape */\n\
  if( flag ){\n\
    for(i=max(g->ymin,g->shapes[sno].ystart);\n\
	i<=min(g->ymax,g->shapes[sno].ystop);\n\
	i++)\n\
      g->ybuf[i] = 1;\n\
  }\n\
  /* mark exclude shape */\n\
  else{\n\
    for(i=g->ymin; i<=g->shapes[sno].ystart-1; i++)\n\
      g->ybuf[i] = 1;\n\
    for(i=g->shapes[sno].ystop+1; i<=g->ymax; i++)\n\
      g->ybuf[i] = 1;\n\
  }\n\
}\n\
\n\
/* ***************************** shape support ***************************** */\n\
\n\
static void quadeq(double a, double b, double c, \n\
		   double *x1, double *x2, int *nr, int *nc)\n\
{\n\
  double dis, q;\n\
  if(a == 0.0){\n\
    *nc = 0;\n\
    if(b == 0.0){\n\
      *nr = 0; *x1 = 0.0;\n\
    }\n\
    else{\n\
      *nr = 1; *x1 = -c / b;\n\
    }\n\
    *x2 = *x1;\n\
  }\n\
  else{\n\
    dis = b*b - 4.0 * a * c;\n\
    if( dis > 0.0 ){\n\
      *nr = 2; *nc = 0;\n\
      dis = sqrt(dis);\n\
      if( b < 0.0 ) dis = -dis;\n\
      q = -0.5 * (b + dis);\n\
      *x1 = q/a; *x2 = c/q;\n\
      if(*x1 > *x2){\n\
	q = *x1; *x1 = *x2; *x2 = q;\n\
      }\n\
    } \n\
    else if( dis == 0.0 ){\n\
      *nr = 1; *nc = 0; *x1 = - 0.5 * b / a; *x2 = *x1;\n\
    }\n\
    else{\n\
      *nr = 0; *nc = 2; *x1 = - 0.5 * b / a; *x2 = 0.5 * sqrt(-dis) / a;\n\
    }\n\
  }\n\
}\n\
\n\
static void rgs_mark(GFilt g, Scan *scanlist, int xval, int yval )\n\
{\n\
  Scan scanmark, mark;\n\
  /* since yval is used as an index, make sure its within limits */\n\
  if(yval < g->ymin) yval = g->ymin;\n\
  if(yval > g->ymax) yval = g->ymax;\n\
  mark = (Scan)malloc(sizeof(ScanRec));\n\
  mark->x = xval;\n\
  /* starts are installed at back of list for given x */\n\
  if( !scanlist[yval] || ((scanlist[yval])->x > xval) ){\n\
    mark->next = scanlist[yval];\n\
    scanlist[yval] = mark;\n\
  } else {\n\
    scanmark = scanlist[yval];\n\
    while( scanmark->next && ((scanmark->next)->x < xval) )\n\
      scanmark = scanmark->next;\n\
    mark->next = scanmark->next;\n\
    scanmark->next = mark;\n\
  }\n\
}\n\
\n\
static void rgs_segment(GFilt g, Scan *scanlist, int width, int height, \n\
			double x1, double y1, double x2, double y2)\n\
{\n\
  int ystart, ystop, yval, xval;\n\
  double invslope, xoffset;\n\
\n\
  ystart = PIXINCL(y1);\n\
  if( ystart < 1 ) ystart = 1;\n\
  /* note: PIXINCL(stop) is 1st pixel not counted */\n\
  ystop = PIXINCL(y2) - 1;\n\
  if( ystop > height ) ystop = height;\n\
  /* ignore segment if there is no positive slope in integer coords */\n\
  if( (ystart > ystop) || (ystop < 1) )\n\
    return;\n\
  /* use inverse slope (run/rise) to get x given y with a multiply */\n\
  invslope = (x1 - x2) / (y1 - y2);\n\
  xoffset = x1 + ((ystart - y1) * invslope);\n\
  for(yval=ystart; yval<=ystop; yval++){\n\
    xval = PIXINCL(xoffset);\n\
    /* clip line to edges of image area (actually bend line) */\n\
    if(xval < 1)     xval = 1;\n\
    if(xval > width) xval = width + 1;\n\
    rgs_mark(g, scanlist, xval, yval);\n\
    xoffset = xoffset + invslope;\n\
  }\n\
}\n\
\n\
static void _polygoni(GFilt g, int rno, int sno, int flag,\n\
		      double *vx, double *vy, int count)\n\
{\n\
  int i, j;\n\
  double xlo, xhi;\n\
  double ylo, yhi;\n\
\n\
  /* divide by block factor to get real endpoints */\n\
  for(i=0; i<count; i++){\n\
    vx[i] /= (double)g->block;\n\
    vy[i] /= (double)g->block;\n\
  }\n\
\n\
  /* find the limits */\n\
  xlo = vx[0];\n\
  xhi = xlo;\n\
  ylo = vy[0];\n\
  yhi = ylo;\n\
  for(i=0; i<count; i++){\n\
    if(vx[i] > xhi) xhi = vx[i];\n\
    if(vx[i] < xlo) xlo = vx[i];\n\
    if(vy[i] > yhi) yhi = vy[i];\n\
    if(vy[i] < ylo) ylo = vy[i];\n\
  }\n\
  g->shapes[sno].ystart = max(g->ymin,PIXINCL(ylo));\n\
  g->shapes[sno].ystop = min(g->ymax,PIXINCL(yhi) - 1);\n\
  g->shapes[sno].scanlist = (Scan *)calloc(g->ymax+1, sizeof(Scan));\n\
  marky(g, sno, flag);\n\
\n\
  /* mark all horizontal segment crossings */\n\
  /* start with segment between last and first point */\n\
  j = count-1;\n\
  for(i=0; i<count; i++){\n\
    /* make segments always run from lower y to higher y */\n\
    if(vy[i] > vy[j]){\n\
      rgs_segment(g, g->shapes[sno].scanlist, g->xmax, g->ymax,\n\
		  vx[j], vy[j], vx[i], vy[i]);\n\
    }\n\
    else{\n\
      rgs_segment(g, g->shapes[sno].scanlist, g->xmax, g->ymax,\n\
		  vx[i], vy[i], vx[j], vy[j]);\n\
    }\n\
    j = i;\n\
  }\n\
}\n\
\n\
static int corner_vertex(int index, int width, int height,\n\
			 double *x, double *y)\n\
{\n\
  switch (index) {\n\
  case 1:\n\
    *x = 0.0;\n\
    *y = height + 1;\n\
    break;\n\
  case 2:\n\
    *x = 0.0;\n\
    *y = 0.0;\n\
    break;\n\
  case 3:\n\
    *x = width + 1;\n\
    *y = 0.0;\n\
    break;\n\
  case 4:\n\
    *x = width + 1;\n\
    *y = height + 1;\n\
  default:\n\
    break;\n\
  }\n\
  index = index + 1;\n\
  if(index > 4) index = 1;\n\
  return(index);\n\
}\n\
\n\
static int pie_intercept(int width, double height, double xcen, double ycen,\n\
			 double angle, double *xcept, double *ycept)\n\
{\n\
  double angl, slope;	/* l: angle and slope of ray */\n\
  angl = angle;\n\
  /* put angles in normal range */\n\
  while (angl < 0.0)\n\
    angl = angl + 360.0;\n\
  while (angl >= 360.0)\n\
    angl = angl - 360.0;\n\
  /* check for a horizontal angle */\n\
  if(fabs(angl - 90.0) < SMALL_NUMBER) {\n\
    *xcept = 0.0;\n\
    *ycept = ycen;\n\
    return(2);\n\
  }\n\
  if(fabs(angl - 270.0) < SMALL_NUMBER) {\n\
    *xcept = width + 1;\n\
    *ycept = ycen;\n\
    return(4);\n\
  }\n\
  /* convert to a Cartesian angle */\n\
  angl = angl + 90.0;\n\
  if(angl >= 360.0)\n\
    angl = angl - 360.0;\n\
  if(angl < 180.0) {\n\
    *ycept = height + 1;\n\
    /* rule out vertical line */\n\
    if(fabs(angl - 90.0) < SMALL_NUMBER) {\n\
      *xcept = xcen;\n\
      return(1);\n\
    }\n\
  } else {\n\
    *ycept = 0.0;\n\
    /* rule out vertical line */\n\
    if(fabs(angl - 270.0) < SMALL_NUMBER) {\n\
      *xcept = xcen;\n\
      return(3);\n\
    }\n\
  }\n\
  /* convert to radians */\n\
  angl = (angl / 180.0) * PI;\n\
  /* calculate slope */\n\
  slope = tan(angl);\n\
  /* calculate intercept with designated y edge */\n\
  *xcept = xcen + ((*ycept - ycen) / slope);\n\
  if(*xcept < 0) {\n\
    *ycept = (ycen - (xcen * slope));\n\
    *xcept = 0.0;\n\
    return(2);\n\
  } else if(*xcept > (width + 1)) {\n\
    *ycept = (ycen + ((width + 1 - xcen) * slope));\n\
    *xcept = width + 1;\n\
    return(4);\n\
  } else {\n\
    if(*ycept < height)\n\
      return(3);\n\
    else\n\
      return(1);\n\
  }\n\
}\n\
\n\
/* ***************************** shapes ********************************** */\n\
\n\
void imannulusi(GFilt g, int rno, int sno, int flag, double x, double y,\n\
		double xcen, double ycen, double iradius, double oradius)\n\
{\n\
  int yy;\n\
  double dval;\n\
  double xoff, yoff;\n\
  Scan *scanlist;\n\
\n\
  /* NB: do not use x and y variables, they have bogus values */\n\
\n\
  /* divide by block factor to get \"real\" parameters */\n\
  xcen /= (double)g->block;\n\
  ycen /= (double)g->block;\n\
  iradius /= (double)g->block;\n\
  oradius /= (double)g->block;\n\
  /* set y limits */\n\
  g->shapes[sno].ystart = max(g->ymin,PIXSTART(ycen - oradius));\n\
  g->shapes[sno].ystop = min(g->ymax,PIXSTOP(ycen + oradius));\n\
  g->shapes[sno].scanlist = (Scan *)calloc(g->ymax+1, sizeof(Scan));\n\
  scanlist = g->shapes[sno].scanlist;\n\
  marky(g, sno, flag);\n\
  /* calculate start/stop values for each y line */\n\
  for(yy=g->shapes[sno].ystart; yy<=g->shapes[sno].ystop; yy++){\n\
    yoff = PIXCEN(yy) - ycen;\n\
    if( (dval=(oradius * oradius) - (yoff * yoff))>=0.0 ){\n\
      xoff = sqrt(dval);\n\
      rgs_mark(g, scanlist, PIXSTART(xcen - xoff), yy);\n\
      rgs_mark(g, scanlist, PIXSTOP(xcen + xoff), yy);\n\
      if( (dval=(iradius * iradius) - (yoff * yoff))>0.0 ){\n\
	xoff = sqrt(dval);\n\
	rgs_mark(g, scanlist, PIXSTART(xcen - xoff), yy);\n\
	rgs_mark(g, scanlist, PIXSTOP(xcen + xoff), yy);\n\
      }\n\
    }\n\
  }\n\
}\n\
\n\
int imannulus(GFilt g, int rno, int sno, int flag, double x, double y,\n\
	      double xcen, double ycen, double iradius, double oradius)\n\
{\n\
  Scan scan;\n\
  if( g->evsect ){\n\
    x = (int)(x - g->tlminx + g->tloff);\n\
    y = (int)(y - g->tlminy + g->tloff);\n\
  }\n\
  scan = g->shapes[sno].scanlist[(int)y];\n\
  if( (scan							&& \n\
       ((y >= g->shapes[sno].ystart) && (y <= g->shapes[sno].ystop))	&&\n\
       (scan->next->next ?\n\
	(((x >= scan->x) && (x <= scan->next->next->next->x))	&&\n\
	 !((x >= scan->next->x) && (x <= scan->next->next->x))) :\n\
	((x >= scan->x) && (x <= scan->next->x))))\n\
      ==flag ){\n\
    if( flag ) g->rid = rno;\n\
    return 1;\n\
  }\n\
  else\n\
    return 0;\n\
}\n\
\n\
void imboxi(GFilt g, int rno, int sno, int flag, double x, double y,\n\
	    double xcen, double ycen, double xwidth, double yheight,\n\
	    double angle)\n\
{\n\
  double angl;			 /* l: Cartesian angle in radians */\n\
  double half_width, half_height;/* l: radii (1/2 width and height) */\n\
  double cosangl, sinangl;	 /* l: sine, cosine of the Cartesian angle */\n\
  double hw_cos, hw_sin;	 /* l: products of half_width with sin, cos */\n\
  double hh_cos, hh_sin;	 /* l: products of half_height with sin, cos */\n\
  double cornerx[4], cornery[4]; /* l: arrays of x and y coords of 4 corners */\n\
\n\
  /* NB: do not use x and y variables, they have bogus values */\n\
\n\
  /* divide by block factor to get \"real\" parameters */\n\
  xcen /= (double)g->block;\n\
  ycen /= (double)g->block;\n\
  xwidth /= (double)g->block;\n\
  yheight /= (double)g->block;\n\
  /* convert to a Cartesian angle; save angle for use in multi or slices */\n\
  angl = angle + 90.0;\n\
  while (angl >= 360.0) angl = angl - 360.0;\n\
  /* convert to radians */\n\
  angl = (angl / 180.0) * PI;\n\
  sinangl = sin (angl);\n\
  cosangl = cos (angl);\n\
  /* since we rotate by 90.0 degrees to get from astro angle to cartesian, */\n\
  /* we also need to switch the width and height. we do this secretly so */\n\
  /* that the display will turn out right, by doing it in the half terms */\n\
  half_width = yheight / 2.0;\n\
  half_height = xwidth / 2.0;\n\
  hw_cos = half_width * cosangl;\n\
  hw_sin = half_width * sinangl;\n\
  hh_cos = half_height * cosangl;\n\
  hh_sin = half_height * sinangl;\n\
  cornerx[0] = xcen - hw_cos - hh_sin;\n\
  cornery[0] = ycen - hw_sin + hh_cos;\n\
  cornerx[1] = xcen + hw_cos - hh_sin;\n\
  cornery[1] = ycen + hw_sin + hh_cos;\n\
  cornerx[2] = xcen + hw_cos + hh_sin;\n\
  cornery[2] = ycen + hw_sin - hh_cos;\n\
  cornerx[3] = xcen - hw_cos + hh_sin;\n\
  cornery[3] = ycen - hw_sin - hh_cos;\n\
  _polygoni(g, rno, sno, flag, cornerx, cornery, 4);\n\
}\n\
\n\
int imbox(GFilt g, int rno, int sno, int flag, double x, double y,\n\
	  double xcen, double ycen, double xwidth, double yheight,\n\
	  double angle)\n\
{\n\
  return impolygon(g, rno, sno, flag, x, y);\n\
}\n\
\n\
void imcirclei(GFilt g, int rno, int sno, int flag, double x, double y,\n\
	       double xcen, double ycen, double radius)\n\
{\n\
  int yy;\n\
  double dval;\n\
  double xoff, yoff;\n\
  Scan *scanlist;\n\
\n\
  /* NB: do not use x and y variables, they have bogus values */\n\
\n\
  /* divide by block factor to get \"real\" parameters */\n\
  xcen /= (double)g->block;\n\
  ycen /= (double)g->block;\n\
  radius /= (double)g->block;\n\
  /* set y limits */\n\
  g->shapes[sno].ystart = max(g->ymin,PIXSTART(ycen - radius));\n\
  g->shapes[sno].ystop = min(g->ymax,PIXSTOP(ycen + radius));\n\
  g->shapes[sno].scanlist = (Scan *)calloc(g->ymax+1, sizeof(Scan));\n\
  scanlist = g->shapes[sno].scanlist;\n\
  marky(g, sno, flag);\n\
  /* calculate start/stop values for each y line */\n\
  for(yy=g->shapes[sno].ystart; yy<=g->shapes[sno].ystop; yy++){\n\
    yoff = PIXCEN(yy) - ycen;\n\
    if( (dval=(radius * radius) - (yoff * yoff))>=0.0 ){\n\
      xoff = sqrt(dval);\n\
      rgs_mark(g, scanlist, PIXSTART(xcen - xoff), yy);\n\
      rgs_mark(g, scanlist, PIXSTOP(xcen + xoff), yy);\n\
    }\n\
  }\n\
}\n\
\n\
int imcircle(GFilt g, int rno, int sno, int flag, double x, double y,\n\
	     double xcen, double ycen, double radius)\n\
{\n\
  Scan scan;\n\
  if( g->evsect ){\n\
    x = (int)(x - g->tlminx + g->tloff);\n\
    y = (int)(y - g->tlminy + g->tloff);\n\
  }\n\
  scan = g->shapes[sno].scanlist[(int)y];\n\
  if( (scan 							&& \n\
      ((y>=g->shapes[sno].ystart) && (y<=g->shapes[sno].ystop))	&&\n\
      ((x >= scan->x) && (x <= (scan->next)->x))) == flag ){\n\
    if( flag ) g->rid = rno;\n\
    return 1;\n\
  }\n\
  else{\n\
   return 0;\n\
  }\n\
}\n\
\n\
void imellipsei(GFilt g, int rno, int sno, int flag, double x, double y,\n\
		double xcen, double ycen, double xrad, double yrad,\n\
		double angle)\n\
{\n\
  int yy;\n\
  int nr, nc;\n\
  double yhi;\n\
  double yoff;\n\
  double xboff, xfoff;\n\
  double angl;\n\
  double sinangl, cosangl;\n\
  double cossq, sinsq, xradsq, yradsq;\n\
  double a, b_partial, c_partial;\n\
  double b, c;\n\
  Scan *scanlist;\n\
\n\
  /* NB: do not use x and y variables, they have bogus values */\n\
\n\
  /* divide by block factor to get \"real\" parameters */\n\
  xcen /= (double)g->block;\n\
  ycen /= (double)g->block;\n\
  xrad /= (double)g->block;\n\
  yrad /= (double)g->block;\n\
  /* set worst case limits (xrad axis parallel to vertical axis) */\n\
  /* convert to a Cartesian angle; save \"angle\" for use by other routines */\n\
  angl = angle + 90.0;\n\
  while( angl >= 360.0 )\n\
    angl = angl - 360.0;\n\
  /* convert to radians */\n\
  angl = (angl / 180.0) * PI;\n\
  sinangl = sin(angl);\n\
  cosangl = cos(angl);\n\
  /* calculate approximate y limits */\n\
  /* choose lesser of containing rotbox and circle */\n\
  yhi = fabs(sinangl * yrad) + fabs(cosangl * xrad);\n\
  yhi = min(yhi, max(yrad, xrad));\n\
  g->shapes[sno].ystart = max(g->ymin,PIXSTART(ycen - yhi));\n\
  g->shapes[sno].ystop = min(g->ymax,PIXSTOP (ycen + yhi));\n\
  g->shapes[sno].scanlist = (Scan *)calloc(g->ymax+1, sizeof(Scan));\n\
  scanlist = g->shapes[sno].scanlist;\n\
  marky(g, sno, flag);\n\
  /* prepare partials for quadratic equation solutions to coordinates */\n\
  cossq = cosangl * cosangl;\n\
  sinsq = sinangl * sinangl;\n\
  /* because we rotate by 90.0 degrees to get from astro angle to */\n\
  /* cartesian, we also need to switch the x and y axes. we do this */\n\
  /* secretly so that the display will turn out right, by doing it in */\n\
  /* the sq terms */\n\
  xradsq = yrad * yrad;\n\
  yradsq = xrad * xrad;\n\
  /* fill in as much of a,b,c as we can */\n\
  a = (cossq / xradsq) + (sinsq / yradsq);\n\
  b_partial = (2.0 * sinangl) * ((cosangl / xradsq) - (cosangl / yradsq));\n\
  c_partial = (sinsq / xradsq) + (cossq / yradsq);\n\
  /* calculate start/stop values for each y line */\n\
  for(yy=g->shapes[sno].ystart; yy<=g->shapes[sno].ystop; yy++){\n\
    yoff = yy - ycen;\n\
    b = b_partial * yoff;\n\
    c = (c_partial * yoff * yoff) - 1.0;\n\
    /* solve quadratic */\n\
    quadeq (a, b, c, &xboff, &xfoff, &nr, &nc);\n\
    /* if real roots */\n\
    if( nr != 0 ) {\n\
      /* translate x coordinates */\n\
      rgs_mark(g, scanlist, PIXSTART(xcen + xboff), yy);\n\
      rgs_mark(g, scanlist, PIXSTOP(xcen + xfoff), yy);\n\
    }\n\
  }\n\
}\n\
\n\
int imellipse(GFilt g, int rno, int sno, int flag, double x, double y,\n\
	      double xcen, double ycen, double xrad, double yrad, double angle)\n\
{\n\
  Scan scan;\n\
  if( g->evsect ){\n\
    x = (int)(x - g->tlminx + g->tloff);\n\
    y = (int)(y - g->tlminy + g->tloff);\n\
  }\n\
  scan = g->shapes[sno].scanlist[(int)y];\n\
  if( (scan 							&& \n\
      ((y>=g->shapes[sno].ystart) && (y<=g->shapes[sno].ystop))	&&\n\
      ((x >= scan->x) && (x <= (scan->next)->x))) == flag ){\n\
    if( flag ) g->rid = rno;\n\
    return 1;\n\
  }\n\
  else\n\
    return 0;\n\
}\n\
\n\
void imfieldi(GFilt g, int rno, int sno, int flag, double x, double y)\n\
{\n\
  /* NB: do not use x and y variables, they have bogus values */\n\
\n\
  g->shapes[sno].ystart = g->ymin;\n\
  g->shapes[sno].ystop = g->ymax;\n\
  marky(g, sno, flag);\n\
}\n\
\n\
int imfield(GFilt g, int rno, int sno, int flag, double x, double y)\n\
{\n\
  if( flag ){\n\
    g->rid = rno;\n\
    return 1;\n\
  }\n\
  else{\n\
    return 0;\n\
  }\n\
}\n\
\n\
void imlinei(GFilt g, int rno, int sno, int flag, double x, double y,\n\
	     double x1, double y1, double x2, double y2)\n\
{\n\
  double vx[2];\n\
  double vy[2];\n\
  int xval, yval;\n\
  double invslope, xoffset;\n\
\n\
  /* NB: do not use x and y variables, they have bogus values */\n\
\n\
  /* divide by block factor to get \"real\" parameters */\n\
  x1 /= (double)g->block;\n\
  y1 /= (double)g->block;\n\
  x2 /= (double)g->block;\n\
  y2 /= (double)g->block;\n\
  /* order by increasing y */\n\
  if( y1 < y2 ){\n\
    vx[0] = x1;\n\
    vy[0] = y1;\n\
    vx[1] = x2;\n\
    vy[1] = y2;\n\
  }\n\
  else{\n\
    vx[0] = x2;\n\
    vy[0] = y2;\n\
    vx[1] = x1;\n\
    vy[1] = y1;\n\
  }\n\
  /* set y limits */\n\
  g->shapes[sno].ystart = PIXNUM(vy[0]);\n\
  g->shapes[sno].ystop = PIXNUM(vy[1]);\n\
  g->shapes[sno].scanlist = (Scan *)calloc(g->ymax+1, sizeof(Scan));\n\
  marky(g, sno, flag);\n\
  if( feq(vy[0],vy[1]) ){\n\
    rgs_mark(g, g->shapes[sno].scanlist, min(vx[0],vx[1]), vy[0]);\n\
    rgs_mark(g, g->shapes[sno].scanlist, max(vx[0],vx[1]), vy[0]);\n\
  }\n\
  else{\n\
    /* mark all horizontal segment crossings */\n\
    invslope = (vx[0] - vx[1]) / (vy[0] - vy[1]);\n\
    xoffset = vx[0];\n\
    for(yval=vy[0]; yval<=vy[1]; yval++){\n\
      xval = xoffset;\n\
      rgs_mark(g, g->shapes[sno].scanlist, xval, yval);\n\
      xoffset = xoffset + invslope;\n\
    }\n\
  }\n\
}\n\
\n\
int imline(GFilt g, int rno, int sno, int flag, double x, double y,\n\
	   double x1, double y1, double x2, double y2)\n\
{\n\
  Scan scan;\n\
  if( g->evsect ){\n\
    x = (int)(x - g->tlminx + g->tloff);\n\
    y = (int)(y - g->tlminy + g->tloff);\n\
  }\n\
  scan = g->shapes[sno].scanlist[(int)y];\n\
  if( (scan                                     &&\n\
      ((x==(int)scan->x)) 			||\n\
       (scan->next&&((x>=(int)scan->x)&&(x<=(int)scan->next->x))))==flag ) {\n\
    if( flag ) g->rid = rno;\n\
    return 1;\n\
  }\n\
  else\n\
    return 0;\n\
}\n\
\n\
void impiei(GFilt g, int rno, int sno, int flag, double x, double y,\n\
	    double xcen, double ycen, double angle1, double angle2)\n\
{\n\
  int width, height;		/* l: image mask width and height */\n\
  double sweep;			/* l: sweep between cut angles */\n\
  double vx[7], vy[7];		/* l: arrays of vertices for polygon */\n\
  int count;			/* l: number of polygon vertices */\n\
  int intrcpt1, intrcpt2;	/* l: side intercepted by each cut */\n\
  double x2, y2;		/* l: coordinates of second intercept */\n\
\n\
  /* NB: do not use x and y variables, they have bogus values */\n\
\n\
  /* divide by block factor to get \"real\" parameters */\n\
  xcen /= (double)g->block;\n\
  ycen /= (double)g->block;\n\
  /* temps */\n\
  width = g->xmax;\n\
  height = g->ymax;\n\
  /* start listing vertices of polygon */\n\
  vx[0] = xcen;\n\
  vy[0] = ycen;\n\
  sweep = angle2 - angle1;\n\
  /* if sweep is too small to be noticed, don't bother */\n\
  if(fabs(sweep) < SMALL_NUMBER)\n\
    return;\n\
  if (sweep < 0.0) sweep = sweep + 360.0;\n\
  intrcpt1 = pie_intercept(width, height, xcen, ycen, angle1,\n\
			   &(vx[1]), &(vy[1]));\n\
  intrcpt2 = pie_intercept(width, height, xcen, ycen, angle2,\n\
			   &x2, &y2);\n\
  count = 2;\n\
  /* if angles intercept same side and slice is between them, no corners */\n\
  /* else, mark corners until reaching side with second angle intercept */\n\
  if((intrcpt1 != intrcpt2) || (sweep > 180.0)){\n\
    do{\n\
      intrcpt1 = corner_vertex(intrcpt1, width, height,  \n\
			       &(vx[count]), &(vy[count]));\n\
      count = count + 1;\n\
    }while(intrcpt1 != intrcpt2);\n\
  }\n\
  vx[count] = x2;\n\
  vy[count] = y2;\n\
  count++;\n\
  _polygoni(g, rno, sno, flag, vx, vy, count);\n\
}\n\
\n\
int impie(GFilt g, int rno, int sno, int flag, double x, double y,\n\
	  double xcen, double ycen, double angle1, double angle2)\n\
{\n\
  return impolygon(g, rno, sno, flag, x, y);\n\
}\n\
\n\
void impointi(GFilt g, int rno, int sno, int flag, double x, double y,\n\
	      double xcen, double ycen)\n\
{\n\
  /* NB: do not use x and y variables, they have bogus values */\n\
\n\
  /* divide by block factor to get \"real\" parameters */\n\
  xcen /= (double)g->block;\n\
  ycen /= (double)g->block;\n\
  /* set y limits */\n\
  g->shapes[sno].ystart = PIXNUM(ycen);\n\
  g->shapes[sno].ystop = PIXNUM(ycen);\n\
  g->shapes[sno].scanlist = (Scan *)calloc(g->ymax+1, sizeof(Scan));\n\
  marky(g, sno, flag);\n\
  rgs_mark(g, g->shapes[sno].scanlist, PIXNUM(xcen), PIXNUM(ycen));\n\
}\n\
\n\
int impoint(GFilt g, int rno, int sno, int flag, double x, double y,\n\
	    double xcen, double ycen)\n\
{\n\
  Scan scan;\n\
  if( g->evsect ){\n\
    x = (int)(x - g->tlminx + g->tloff);\n\
    y = (int)(y - g->tlminy + g->tloff);\n\
  }\n\
  scan = g->shapes[sno].scanlist[(int)y];\n\
  if( (scan                                     &&\n\
      (y == (int)g->shapes[sno].ystart)		&& \n\
      (x == (int)scan->x))==flag )		{\n\
    if( flag ) g->rid = rno;\n\
    return 1;\n\
  }\n\
  else\n\
    return 0;\n\
}\n\
\n\
#ifdef __STDC__\n\
void\n\
impolygoni(GFilt g, int rno, int sno, int flag, double x, double y, ...)\n\
{\n\
  double *vx=NULL, *vy=NULL;\n\
  int count, maxcount;\n\
  va_list args;\n\
  va_start(args, y);\n\
#else\n\
void impolygoni(va_alist) va_dcl\n\
{\n\
  GFilt g;\n\
  int rno, sno, flag;\n\
  double x, y;\n\
  double *vx=NULL, *vy=NULL;\n\
  int count, maxcount;\n\
  va_list args;\n\
  va_start(args);\n\
\n\
  g  =  va_arg(args, GFilt);\n\
  rno  = va_arg(args, int);\n\
  sno  = va_arg(args, int);\n\
  flag  = va_arg(args, int);\n\
  x = va_arg(args, double);\n\
  y = va_arg(args, double);\n\
#endif\n\
  /* NB: do not use x and y variables, they have bogus values */\n\
\n\
  /* allocate space for x,y arguments */\n\
  maxcount = MASKINC;\n\
  vx = (double *)malloc(maxcount*sizeof(double));\n\
  vy = (double *)malloc(maxcount*sizeof(double));\n\
  /* look for x,y arguments */\n\
  count = 0;\n\
  while( 1 ){\n\
    if( (count + 1) >= maxcount ){\n\
      maxcount += MASKINC;\n\
      vx = (double *)realloc(vx, maxcount*sizeof(double));\n\
      vy = (double *)realloc(vy, maxcount*sizeof(double));\n\
    }\n\
    vx[count] = va_arg(args, double);\n\
    vy[count] = va_arg(args, double);\n\
    if( feq(vx[count],PSTOP) && feq(vy[count],PSTOP) )\n\
      break;\n\
    count ++;\n\
  }\n\
  va_end(ap);\n\
  /* realloc to actual size */\n\
  vx = (double *)realloc(vx, count*sizeof(double));\n\
  vy = (double *)realloc(vy, count*sizeof(double));\n\
  /* call the common routine */\n\
  _polygoni(g, rno, sno, flag, vx, vy, count);\n\
  if( vx ) free(vx);\n\
  if( vy ) free(vy);\n\
}\n\
\n\
#ifdef __STDC__\n\
int\n\
impolygon(GFilt g, int rno, int sno, int flag, double x, double y, ...)\n\
{\n\
  int crossings;\n\
  Scan scan;\n\
  /*\n\
  va_list args;\n\
  va_start(args, y);\n\
  */\n\
#else\n\
int impolygon(va_alist) va_dcl\n\
{\n\
  GFilt g;\n\
  int rno, sno, flag;\n\
  double x, y;\n\
  int crossings;\n\
  Scan scan;\n\
  va_list args;\n\
  va_start(args);\n\
  g  = va_arg(args, GFilt);\n\
  rno  = va_arg(args, int);\n\
  sno  = va_arg(args, int);\n\
  flag  = va_arg(args, int);\n\
  x = va_arg(args, double);\n\
  y = va_arg(args, double);\n\
#endif\n\
  if( g->evsect ){\n\
    x = (int)(x - g->tlminx + g->tloff);\n\
    y = (int)(y - g->tlminy + g->tloff);\n\
  }\n\
  /* no initialization of x for this row, just jump right in */\n\
  if( (y>=g->shapes[sno].ystart)&&(y<=g->shapes[sno].ystop) ){\n\
    crossings = 0;\n\
    for(scan=g->shapes[sno].scanlist[(int)y]; scan; scan=scan->next){\n\
      if( x >= scan->x )\n\
	crossings++;\n\
      else\n\
	break;\n\
    }\n\
    if( fmod((double)crossings,2.0) == flag ){\n\
      if( flag ) g->rid = rno;\n\
      return 1;\n\
    }\n\
    else\n\
      return 0;\n\
  }\n\
  else\n\
    return !flag;\n\
}\n\
\n\
"
