#ifndef __basecircle_h__
#define __basecircle_h__

#include "basemarker.h"

class BaseCircle : public BaseMarker {
protected:
  double* radii;

  void render(Drawable, const Matrix&, GC, double);

public:
  BaseCircle(Frame* p, const Vector& ctr, double r,
	     const char* clr, const char* f, 
	     const char* t, unsigned short prop);
  virtual ~BaseCircle();

  virtual void updateBBox() =0;
  void updateCoords(Matrix&);
  void draw();
  void drawXOR();
  void drawMagnifier(const Matrix&);
  virtual void edit(const Vector&, int) =0;
  virtual void endEnd() {}
  void ps(int);
  int isIn(const Vector&);

  virtual void list(ostream&, int, int, const char*) =0;
  virtual void listCiao(ostream&, int, int, const char*) =0;
  virtual void listFtools(ostream&, int, int, const char*) =0;
  virtual void listSAOimage(ostream&, const char*) =0;
  virtual void listPros(ostream&, int, int, const char*) =0;
};

#endif
