#ifndef __contourscale_h__
#define __contourscale_h__

#include <iostream.h>

class ContourScale {
protected:
  float* level_;
  int size_;

public:
  ContourScale(int);
  ContourScale(int, float*);
  virtual ~ContourScale();

  int size() {return size_+1;}
  float level(int i) {return level_[i];}

  friend ostream& operator<<(ostream&, const ContourScale&);
};

class LinearContourScale : public ContourScale {
public:
  LinearContourScale(int, float, float);
};

class LogContourScale : public ContourScale {
public:
  LogContourScale(int, float, float);
};

class SquaredContourScale : public ContourScale {
public:
  SquaredContourScale(int, float, float);
};

class SqrtContourScale : public ContourScale {
public:
  SqrtContourScale(int, float, float);
};

#endif
